Subject: Re: publishing OF platform devices

From: Arnd Bergmann <[email-masked]>
Date: Thu, 29 Mar 2007 23:57:04 +0200

On Thursday 29 March 2007, Sylvain Munaut wrote:
> John Rigby wrote:
> > I have a question about the "right" way to publish platform
> > devices via of_platform_bus_probe.
> >
> > On 5200 platforms it gets called from
> > mpc52xx_declare_of_platform_devices which is registered as the
> > machdep_calls init routine.
> > =A0=20
> It's called by machdep calls so that it's only called if the platform is
> detected ...
> > On other platforms it is called via a device_initcall
> > =A0=20
> That will always be called which is bad.
>=20
> Because if you have a kernel will multiple platform support built in, it
> will
> be called everytime, even if it's not running on the good platform.

The ppc_md->init() function is currently only present on 32 bit,
if we decide that this is the way to go, we should make it common
to both 32 and 64 bit platforms.

> > Also I noticed that some 83xx platforms don't call
> > of_platform_bus_probe at all. =A0Thats ok because most of those devices
> > are register various routines in fsl_soc.c. =A0The one I have not
> > figured out yet is spi, I don't see anyone registering mpc83xx_spi?
> >
> On theses I have no idea ...

They should be converted to use of_platform_bus_probe in the future. As soon
as we have of_platform_drivers for the devices probed in fsl_soc.c, we can
get rid of that file.

	Arnd <><